---
date: 2020-09-29
id: 547d6700-cedd-4273-9f12-1fd4da96b695
title: TypeScript
---

# Types

-   [Arrays](20200929162129-arrays)
-   [Enums](20200930110721-typescript_enums)
-   [Generics](20200929163051-typescript_generics)
-   [Intersection Type](20200929163316-typescript_intersection_type)
-   [Literal Types](20201002103357-typescript_literal_types)
-   [Mapped Type](20201124085335-typescript_mapped_type)
-   [Never Type](20201007095614-typescript_never_type)
-   [Primitive Types](20200929161544-primitive_types)
-   [Recursive Conditional
    Types](20201125085727-typescript_recursive_conditional_types)
-   [Tuple Type](20200929163624-typescript_tuple_type)
-   [Union Type](20200929163219-typescript_union_type)

# Objects

-   [Classes](20201009104411-typescript_classes)
-   [Inline Type Annotation](20200929162417-inline_type_annotation)
-   [Interfaces](20200929162220-interfaces)

# Functions

-   [Functions](20201001110806-typescript_functions)

# Declarations

-   [Ambient Declarations](20200930105954-ambient_declarations)
-   [lib.d.ts](20201001105545-lib_d_ts)

# Syntax

-   [Callable](20201001112126-typescript_callable)
-   [Discriminated Union](20201007101133-typescript_discriminated_union)
-   [Index Signatures](20201008092225-index_signatures)
-   [Readonly](20201005171253-readonly)
-   [Type Alias](20200929163825-typescript_type_alias)
-   [Type Assertion](20201002101745-typescript_type_assertion)
-   [Type Guard](20201002102455-typescript_type_guard)

# Clauses

-   [as](20201124095453-typescript_as_clause)

# Keywords

-   [in](20201124090450-typescript_in_operator)

# Configuration

-   [Flags](20201127101043-typescript_flags)

# Books

-   [TypeScript Deep Dive](https://basarat.gitbook.io/typescript/)
-   [Style Guide](https://basarat.gitbook.io/typescript/styleguide)

# Changes

-   [4.0](20201009104050-typescript_4_0)
-   [4.1](20201123094735-typescript_4_1)
